#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <math.h>
#include <string.h>
#include <assert.h>

#define STB_IMAGE_WRITE_IMPLEMENTATION
#include "stb/stb_image.h"
#include "stb/stb_image_write.h"

#include "primitives.h"
#include "point.h"
#include "stack.h"

// convertit les coordonnées dans l'espace du dessin
double cX(int x)
{
    return 0.1+x / 15.;
}

double cY(int y)
{
    return -0.1+1-(1+y) / 15.;
}

int main(int argc, char **argv)
{
    int W = 1000;
    int H = 500;

    point tab[] = {
        { 0, 0 }, { 1, 4 }, { 1, 8 }, { 4, 1 }, { 4, 4 }, { 5, 9 },
        { 5, 6 }, { 7, -1 }, { 7, 2 }, { 8, 5 }, { 11, 6 }, { 13, 1 }
    };
    int n = 12;

    int env[12];
    int t = conv_jarvis(tab, n, env);

    for(int i = 0; i < t; i++)
        printf("%d ", env[i]);
    printf("\n");

    stack s_env = conv_graham(tab, n);
    print_stack(s_env);

    initialise(W, H);
    clear();
    fenetre(0, 0, W/2-1, H-1);
    for (int i = 0; i < n; i++)
        cercle_plein(cX(tab[i].x), cY(tab[i].y), 0.01, rgb(0,0,0));
    for(int i = 0; i < t; i++)
        ligne(cX(tab[env[i]].x), cY(tab[env[i]].y),
              cX(tab[env[(i+1)%t]].x), cY(tab[env[(i+1)%t]].y),
              rgb(255, 0, 0));
    fenetre(W/2, 0, W-1, H-1);
    for (int i = 0; i < n; i++)
        cercle_plein(cX(tab[i].x), cY(tab[i].y), 0.01, rgb(0,0,0));

    int dernier = top(s_env);
    while(!is_empty(s_env))
    {
        int i = pop(s_env);
        int j;
        if(is_empty(s_env)) 
        {
            j = dernier;
        }
        else
        {
            j = top(s_env);
        }

        ligne(cX(tab[i].x), cY(tab[i].y),
              cX(tab[j].x), cY(tab[j].y),
              rgb(0, 0, 255));
    }

    stbi_write_png("dm01.png", W, H, 4, get_pixels(), 0);
    detruit();
}

