#include <stdlib.h>
#include <stdio.h>
#include "stack.h"

struct stack_s {
    int *elts;
    int size;
};

const int SIZE_MAX = 1000;

stack new_stack()
{
    stack s = (stack) malloc(sizeof(struct stack_s));
    s->elts = (int *)malloc(SIZE_MAX * sizeof(int));
    s->size = 0;
    return s;
}

bool is_empty(stack s)
{
    return s->size == 0;
}

void push(int i, stack s)
{
    s->elts[s->size] = i;
    s->size = s->size + 1;
}

int top(stack s)
{
    return s->elts[s->size-1];
}

int pop(stack s)
{
    int i = s->elts[s->size-1];
    s->size--;
    return i;
}

void destroy_stack(stack s)
{
    free(s->elts);
    free(s);
}

void print_stack(stack s)
{
    for (int i = 0; i < s->size; ++i)
        printf("%d ", s->elts[i]);
    printf("\n");
}
